(function (document, Drupal) {
  const generateColor = (label) => {
    let r = 0;
    let g = 1;
    let b = 0;
    let code;
    let index = 0;
    for (char of label) {
      code = label.charCodeAt(index);
      r += code;
      g = (g * code) % 200;
      b = (b + code) % 200;
      index++;
    }
    r = r % 200;
    return [r, g, b];
  };
  Drupal.behaviors.debug = {
    attach: function attach(context) {
      document.onreadystatechange = () => {
        const elements = document.getElementsByClassName('cl-component');
        for (el of elements) {
          if (el.getElementsByClassName('cl-component-wrapper__overlay').length) {
            continue;
          }
          const wrapper = document.createElement('div');
          wrapper.className = 'cl-component-wrapper';
          const overlay = document.createElement('div');
          overlay.className = 'cl-component-wrapper__overlay';
          const componentId = el.attributes.getNamedItem('data-cl-component-id').nodeValue;
          const variant = el.attributes.getNamedItem('data-cl-component-variant').nodeValue;
          const componentLabel = document.createElement('div');
          componentLabel.className = 'cl-component-wrapper__overlay__label'
          const labelText = [componentId, variant].filter(Boolean).join(':');
          const [r, g, b] = generateColor(labelText);
          componentLabel.textContent = labelText;
          const cssColor = `rgb(${r}, ${g}, ${b})`;
          componentLabel.style.background = cssColor;
          overlay.appendChild(componentLabel);
          overlay.style.border = `2px solid ${cssColor}`;
          el.appendChild(overlay)
          wrapper.innerHTML = el.outerHTML;
          wrapper.style.width = el.offsetWidth + 12 + 'px';
          el.outerHTML = wrapper.outerHTML;
        }
      }
    },
  };
})(document, Drupal);
